# coding: utf-8

"""
    DocSpring API

    DocSpring provides an API that helps you fill out and sign PDF templates.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictBool, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from docspring.models.submission_action import SubmissionAction
from docspring.models.submission_data_request import SubmissionDataRequest
from typing import Optional, Set
from typing_extensions import Self

class Submission(BaseModel):
    """
    Submission
    """ # noqa: E501
    batch_id: Optional[StrictStr]
    data_requests: List[SubmissionDataRequest]
    editable: Optional[StrictBool]
    expired: StrictBool
    expires_at: Optional[StrictStr]
    id: Optional[StrictStr]
    json_schema_errors: Optional[List[StrictStr]]
    metadata: Dict[str, Any]
    password: Optional[StrictStr]
    processed_at: Optional[StrictStr]
    state: StrictStr
    template_id: Optional[StrictStr]
    template_type: StrictStr
    template_version: Optional[StrictStr]
    test: StrictBool
    truncated_text: Optional[Dict[str, Any]]
    pdf_hash: Optional[StrictStr]
    download_url: Optional[StrictStr]
    permanent_download_url: Optional[StrictStr]
    preview_download_url: Optional[StrictStr]
    preview_generated_at: Optional[StrictStr]
    audit_trail_download_url: Optional[StrictStr]
    actions: List[SubmissionAction]
    source: StrictStr
    referrer: Optional[StrictStr]
    data: Optional[Dict[str, Any]]
    __properties: ClassVar[List[str]] = ["batch_id", "data_requests", "editable", "expired", "expires_at", "id", "json_schema_errors", "metadata", "password", "processed_at", "state", "template_id", "template_type", "template_version", "test", "truncated_text", "pdf_hash", "download_url", "permanent_download_url", "preview_download_url", "preview_generated_at", "audit_trail_download_url", "actions", "source", "referrer", "data"]

    @field_validator('state')
    def state_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['pending', 'processed', 'invalid_data', 'error', 'image_download_failed', 'image_processing_failed', 'waiting_for_data_requests', 'syntax_error', 'account_suspended', 'license_revoked', 'accidental']):
            raise ValueError("must be one of enum values ('pending', 'processed', 'invalid_data', 'error', 'image_download_failed', 'image_processing_failed', 'waiting_for_data_requests', 'syntax_error', 'account_suspended', 'license_revoked', 'accidental')")
        return value

    @field_validator('template_type')
    def template_type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['pdf', 'html']):
            raise ValueError("must be one of enum values ('pdf', 'html')")
        return value

    @field_validator('source')
    def source_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['api', 'web', 'reprocess', 'webhook']):
            raise ValueError("must be one of enum values ('api', 'web', 'reprocess', 'webhook')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Submission from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in data_requests (list)
        _items = []
        if self.data_requests:
            for _item_data_requests in self.data_requests:
                if _item_data_requests:
                    _items.append(_item_data_requests.to_dict())
            _dict['data_requests'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in actions (list)
        _items = []
        if self.actions:
            for _item_actions in self.actions:
                if _item_actions:
                    _items.append(_item_actions.to_dict())
            _dict['actions'] = _items
        # set to None if batch_id (nullable) is None
        # and model_fields_set contains the field
        if self.batch_id is None and "batch_id" in self.model_fields_set:
            _dict['batch_id'] = None

        # set to None if editable (nullable) is None
        # and model_fields_set contains the field
        if self.editable is None and "editable" in self.model_fields_set:
            _dict['editable'] = None

        # set to None if expires_at (nullable) is None
        # and model_fields_set contains the field
        if self.expires_at is None and "expires_at" in self.model_fields_set:
            _dict['expires_at'] = None

        # set to None if id (nullable) is None
        # and model_fields_set contains the field
        if self.id is None and "id" in self.model_fields_set:
            _dict['id'] = None

        # set to None if json_schema_errors (nullable) is None
        # and model_fields_set contains the field
        if self.json_schema_errors is None and "json_schema_errors" in self.model_fields_set:
            _dict['json_schema_errors'] = None

        # set to None if password (nullable) is None
        # and model_fields_set contains the field
        if self.password is None and "password" in self.model_fields_set:
            _dict['password'] = None

        # set to None if processed_at (nullable) is None
        # and model_fields_set contains the field
        if self.processed_at is None and "processed_at" in self.model_fields_set:
            _dict['processed_at'] = None

        # set to None if template_id (nullable) is None
        # and model_fields_set contains the field
        if self.template_id is None and "template_id" in self.model_fields_set:
            _dict['template_id'] = None

        # set to None if template_version (nullable) is None
        # and model_fields_set contains the field
        if self.template_version is None and "template_version" in self.model_fields_set:
            _dict['template_version'] = None

        # set to None if truncated_text (nullable) is None
        # and model_fields_set contains the field
        if self.truncated_text is None and "truncated_text" in self.model_fields_set:
            _dict['truncated_text'] = None

        # set to None if pdf_hash (nullable) is None
        # and model_fields_set contains the field
        if self.pdf_hash is None and "pdf_hash" in self.model_fields_set:
            _dict['pdf_hash'] = None

        # set to None if download_url (nullable) is None
        # and model_fields_set contains the field
        if self.download_url is None and "download_url" in self.model_fields_set:
            _dict['download_url'] = None

        # set to None if permanent_download_url (nullable) is None
        # and model_fields_set contains the field
        if self.permanent_download_url is None and "permanent_download_url" in self.model_fields_set:
            _dict['permanent_download_url'] = None

        # set to None if preview_download_url (nullable) is None
        # and model_fields_set contains the field
        if self.preview_download_url is None and "preview_download_url" in self.model_fields_set:
            _dict['preview_download_url'] = None

        # set to None if preview_generated_at (nullable) is None
        # and model_fields_set contains the field
        if self.preview_generated_at is None and "preview_generated_at" in self.model_fields_set:
            _dict['preview_generated_at'] = None

        # set to None if audit_trail_download_url (nullable) is None
        # and model_fields_set contains the field
        if self.audit_trail_download_url is None and "audit_trail_download_url" in self.model_fields_set:
            _dict['audit_trail_download_url'] = None

        # set to None if referrer (nullable) is None
        # and model_fields_set contains the field
        if self.referrer is None and "referrer" in self.model_fields_set:
            _dict['referrer'] = None

        # set to None if data (nullable) is None
        # and model_fields_set contains the field
        if self.data is None and "data" in self.model_fields_set:
            _dict['data'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Submission from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "batch_id": obj.get("batch_id"),
            "data_requests": [SubmissionDataRequest.from_dict(_item) for _item in obj["data_requests"]] if obj.get("data_requests") is not None else None,
            "editable": obj.get("editable"),
            "expired": obj.get("expired"),
            "expires_at": obj.get("expires_at"),
            "id": obj.get("id"),
            "json_schema_errors": obj.get("json_schema_errors"),
            "metadata": obj.get("metadata"),
            "password": obj.get("password"),
            "processed_at": obj.get("processed_at"),
            "state": obj.get("state"),
            "template_id": obj.get("template_id"),
            "template_type": obj.get("template_type"),
            "template_version": obj.get("template_version"),
            "test": obj.get("test"),
            "truncated_text": obj.get("truncated_text"),
            "pdf_hash": obj.get("pdf_hash"),
            "download_url": obj.get("download_url"),
            "permanent_download_url": obj.get("permanent_download_url"),
            "preview_download_url": obj.get("preview_download_url"),
            "preview_generated_at": obj.get("preview_generated_at"),
            "audit_trail_download_url": obj.get("audit_trail_download_url"),
            "actions": [SubmissionAction.from_dict(_item) for _item in obj["actions"]] if obj.get("actions") is not None else None,
            "source": obj.get("source"),
            "referrer": obj.get("referrer"),
            "data": obj.get("data")
        })
        return _obj


