# coding: utf-8

"""
    DocSpring API

    DocSpring provides an API that helps you fill out and sign PDF templates.

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class TemplatePreview(BaseModel):
    """
    TemplatePreview
    """ # noqa: E501
    add_data_request_submission_id_footers: StrictBool
    allow_additional_properties: StrictBool
    description: Optional[StrictStr]
    document_filename: Optional[StrictStr]
    document_md5: Optional[StrictStr]
    document_parse_error: StrictBool
    document_processed: StrictBool
    document_state: StrictStr
    document_url: Optional[StrictStr]
    editable_submissions: StrictBool
    embed_domains: Optional[StrictStr]
    encrypt_pdfs_password: Optional[StrictStr]
    encrypt_pdfs: StrictBool
    expiration_interval: StrictStr
    expire_after: StrictInt
    expire_submissions: StrictBool
    external_predefined_fields_template_id: Optional[StrictStr]
    external_predefined_fields_template_name: Optional[StrictStr]
    first_template: StrictBool
    id: Optional[StrictStr]
    locked: StrictBool
    merge_audit_trail_pdf: StrictBool
    name: Optional[StrictStr]
    page_count: StrictInt
    page_dimensions: Optional[List[Annotated[List[Union[StrictFloat, StrictInt]], Field(min_length=2, max_length=2)]]]
    parent_folder_id: Optional[StrictStr]
    path: Optional[StrictStr]
    permanent_document_url: Optional[StrictStr]
    public_submissions: StrictBool
    public_web_form: StrictBool
    redirect_url: Optional[StrictStr]
    slack_webhook_url: Optional[StrictStr]
    template_type: StrictStr
    updated_at: Optional[StrictStr]
    version_published_at: Optional[StrictStr]
    version: Optional[StrictStr]
    webhook_url: Optional[StrictStr]
    demo: StrictBool
    latest_version: Optional[StrictStr]
    last_changed_at: Optional[StrictStr]
    last_changed_by_type: Optional[StrictStr]
    last_changed_by_id: Optional[StrictStr]
    __properties: ClassVar[List[str]] = ["add_data_request_submission_id_footers", "allow_additional_properties", "description", "document_filename", "document_md5", "document_parse_error", "document_processed", "document_state", "document_url", "editable_submissions", "embed_domains", "encrypt_pdfs_password", "encrypt_pdfs", "expiration_interval", "expire_after", "expire_submissions", "external_predefined_fields_template_id", "external_predefined_fields_template_name", "first_template", "id", "locked", "merge_audit_trail_pdf", "name", "page_count", "page_dimensions", "parent_folder_id", "path", "permanent_document_url", "public_submissions", "public_web_form", "redirect_url", "slack_webhook_url", "template_type", "updated_at", "version_published_at", "version", "webhook_url", "demo", "latest_version", "last_changed_at", "last_changed_by_type", "last_changed_by_id"]

    @field_validator('document_state')
    def document_state_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['pending', 'processed', 'password_required', 'malformed_pdf', 'unknown_error']):
            raise ValueError("must be one of enum values ('pending', 'processed', 'password_required', 'malformed_pdf', 'unknown_error')")
        return value

    @field_validator('template_type')
    def template_type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['pdf', 'html']):
            raise ValueError("must be one of enum values ('pdf', 'html')")
        return value

    @field_validator('last_changed_by_type')
    def last_changed_by_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['user', 'api']):
            raise ValueError("must be one of enum values ('user', 'api')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TemplatePreview from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if description (nullable) is None
        # and model_fields_set contains the field
        if self.description is None and "description" in self.model_fields_set:
            _dict['description'] = None

        # set to None if document_filename (nullable) is None
        # and model_fields_set contains the field
        if self.document_filename is None and "document_filename" in self.model_fields_set:
            _dict['document_filename'] = None

        # set to None if document_md5 (nullable) is None
        # and model_fields_set contains the field
        if self.document_md5 is None and "document_md5" in self.model_fields_set:
            _dict['document_md5'] = None

        # set to None if document_url (nullable) is None
        # and model_fields_set contains the field
        if self.document_url is None and "document_url" in self.model_fields_set:
            _dict['document_url'] = None

        # set to None if embed_domains (nullable) is None
        # and model_fields_set contains the field
        if self.embed_domains is None and "embed_domains" in self.model_fields_set:
            _dict['embed_domains'] = None

        # set to None if encrypt_pdfs_password (nullable) is None
        # and model_fields_set contains the field
        if self.encrypt_pdfs_password is None and "encrypt_pdfs_password" in self.model_fields_set:
            _dict['encrypt_pdfs_password'] = None

        # set to None if external_predefined_fields_template_id (nullable) is None
        # and model_fields_set contains the field
        if self.external_predefined_fields_template_id is None and "external_predefined_fields_template_id" in self.model_fields_set:
            _dict['external_predefined_fields_template_id'] = None

        # set to None if external_predefined_fields_template_name (nullable) is None
        # and model_fields_set contains the field
        if self.external_predefined_fields_template_name is None and "external_predefined_fields_template_name" in self.model_fields_set:
            _dict['external_predefined_fields_template_name'] = None

        # set to None if id (nullable) is None
        # and model_fields_set contains the field
        if self.id is None and "id" in self.model_fields_set:
            _dict['id'] = None

        # set to None if name (nullable) is None
        # and model_fields_set contains the field
        if self.name is None and "name" in self.model_fields_set:
            _dict['name'] = None

        # set to None if page_dimensions (nullable) is None
        # and model_fields_set contains the field
        if self.page_dimensions is None and "page_dimensions" in self.model_fields_set:
            _dict['page_dimensions'] = None

        # set to None if parent_folder_id (nullable) is None
        # and model_fields_set contains the field
        if self.parent_folder_id is None and "parent_folder_id" in self.model_fields_set:
            _dict['parent_folder_id'] = None

        # set to None if path (nullable) is None
        # and model_fields_set contains the field
        if self.path is None and "path" in self.model_fields_set:
            _dict['path'] = None

        # set to None if permanent_document_url (nullable) is None
        # and model_fields_set contains the field
        if self.permanent_document_url is None and "permanent_document_url" in self.model_fields_set:
            _dict['permanent_document_url'] = None

        # set to None if redirect_url (nullable) is None
        # and model_fields_set contains the field
        if self.redirect_url is None and "redirect_url" in self.model_fields_set:
            _dict['redirect_url'] = None

        # set to None if slack_webhook_url (nullable) is None
        # and model_fields_set contains the field
        if self.slack_webhook_url is None and "slack_webhook_url" in self.model_fields_set:
            _dict['slack_webhook_url'] = None

        # set to None if updated_at (nullable) is None
        # and model_fields_set contains the field
        if self.updated_at is None and "updated_at" in self.model_fields_set:
            _dict['updated_at'] = None

        # set to None if version_published_at (nullable) is None
        # and model_fields_set contains the field
        if self.version_published_at is None and "version_published_at" in self.model_fields_set:
            _dict['version_published_at'] = None

        # set to None if version (nullable) is None
        # and model_fields_set contains the field
        if self.version is None and "version" in self.model_fields_set:
            _dict['version'] = None

        # set to None if webhook_url (nullable) is None
        # and model_fields_set contains the field
        if self.webhook_url is None and "webhook_url" in self.model_fields_set:
            _dict['webhook_url'] = None

        # set to None if latest_version (nullable) is None
        # and model_fields_set contains the field
        if self.latest_version is None and "latest_version" in self.model_fields_set:
            _dict['latest_version'] = None

        # set to None if last_changed_at (nullable) is None
        # and model_fields_set contains the field
        if self.last_changed_at is None and "last_changed_at" in self.model_fields_set:
            _dict['last_changed_at'] = None

        # set to None if last_changed_by_type (nullable) is None
        # and model_fields_set contains the field
        if self.last_changed_by_type is None and "last_changed_by_type" in self.model_fields_set:
            _dict['last_changed_by_type'] = None

        # set to None if last_changed_by_id (nullable) is None
        # and model_fields_set contains the field
        if self.last_changed_by_id is None and "last_changed_by_id" in self.model_fields_set:
            _dict['last_changed_by_id'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TemplatePreview from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "add_data_request_submission_id_footers": obj.get("add_data_request_submission_id_footers"),
            "allow_additional_properties": obj.get("allow_additional_properties"),
            "description": obj.get("description"),
            "document_filename": obj.get("document_filename"),
            "document_md5": obj.get("document_md5"),
            "document_parse_error": obj.get("document_parse_error"),
            "document_processed": obj.get("document_processed"),
            "document_state": obj.get("document_state"),
            "document_url": obj.get("document_url"),
            "editable_submissions": obj.get("editable_submissions"),
            "embed_domains": obj.get("embed_domains"),
            "encrypt_pdfs_password": obj.get("encrypt_pdfs_password"),
            "encrypt_pdfs": obj.get("encrypt_pdfs"),
            "expiration_interval": obj.get("expiration_interval"),
            "expire_after": obj.get("expire_after"),
            "expire_submissions": obj.get("expire_submissions"),
            "external_predefined_fields_template_id": obj.get("external_predefined_fields_template_id"),
            "external_predefined_fields_template_name": obj.get("external_predefined_fields_template_name"),
            "first_template": obj.get("first_template"),
            "id": obj.get("id"),
            "locked": obj.get("locked"),
            "merge_audit_trail_pdf": obj.get("merge_audit_trail_pdf"),
            "name": obj.get("name"),
            "page_count": obj.get("page_count"),
            "page_dimensions": obj.get("page_dimensions"),
            "parent_folder_id": obj.get("parent_folder_id"),
            "path": obj.get("path"),
            "permanent_document_url": obj.get("permanent_document_url"),
            "public_submissions": obj.get("public_submissions"),
            "public_web_form": obj.get("public_web_form"),
            "redirect_url": obj.get("redirect_url"),
            "slack_webhook_url": obj.get("slack_webhook_url"),
            "template_type": obj.get("template_type"),
            "updated_at": obj.get("updated_at"),
            "version_published_at": obj.get("version_published_at"),
            "version": obj.get("version"),
            "webhook_url": obj.get("webhook_url"),
            "demo": obj.get("demo"),
            "latest_version": obj.get("latest_version"),
            "last_changed_at": obj.get("last_changed_at"),
            "last_changed_by_type": obj.get("last_changed_by_type"),
            "last_changed_by_id": obj.get("last_changed_by_id")
        })
        return _obj


